<template>
  <div class="container">
    <div class="text-center pt-4">
      <h2>
        <b>Register</b>
      </h2>
    </div>
    <form>
      <div class="mb-3">
        <label class="form-label">Name</label>
        <input type="text" class="form-control" v-model="nama" required />
        <div id="emailHelp" class="form-text text-danger" v-if="msg.nama">
          {{ msg.nama }}
        </div>
      </div>

      <div class="mb-3">
        <label class="form-label">Username</label>
        <input type="text" class="form-control" v-model="username" required />
        <div id="emailHelp" class="form-text text-danger" v-if="msg.username">
          {{ msg.username }}
        </div>
      </div>

      <div class="mb-3">
        <label for="exampleInputEmail1" class="form-label">Email address</label>
        <input type="email" class="form-control" v-model="email" required />
        <div id="emailHelp" class="form-text text-danger" v-if="msg.email">
          {{ msg.email }}
        </div>
      </div>

      <button type="button" @click="submit" class="btn btn-success">
        Register
      </button>
      <button type="button" @click="authProvider('google')" class="btn btn-outline-dark">
        <i class="bi bi-google"></i> Login With Google
      </button>
    </form>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapMutations } from "vuex";

export default {
  name: "login",
  data() {
    return {
      typeFormPass: true,
      typeFormComPass: true,
      nama: "",
      username: "",
      email: "",
      msg: [],
      type: "password",
    };
  },
  watch: {
    nama(value) {
      this.nama = value;
      this.validatenama(value);
    },
    username(value) {
      this.username = value;
      this.validateusername(value);
    },
    email(value) {
      this.email = value;
      this.validateEmail(value);
    },
  },

  computed: {
    ...mapGetters({
      transactions: "auth/transactions",
      user: "auth/user",
      alert: "alert/alert",
      alertText: "alert/alertText",
    }),
  },

  methods: {
    ...mapMutations({
        setEmail: "auth/setEmail",
      setAuth: "auth/set",
      getAlert: "alert/getAlert",
      closeAlert: "alert/closeAlert",
    }),

    authProvider(provider) {
      let url = "/api/Auth/Sosialite/" + provider;
      axios
        .get(url)
        .then((res) => {
          let data = res.data;
          console.log(data.url);
          window.location.href = data.url
        })
        .catch((err) => {
          console.error(err);
        });
    },

    submit() {
      let formData = {
        name: this.nama,
        username: this.username,
        email: this.email,
      };

      axios({
        method: "post",
        url: "/api/Auth/Register",
        data: formData,
      })
        .then((response) => {
          let dataUserLogin = response.data;
          this.getAlert("Register Berhasil. Silahkan Cek Email Untuk mendapatkan kode OTP");
          this.$router.push("/Verification");
        })
        .catch((error) => {
          alert("catch error");
          console.log(error);
        });
    },

    validatenama(value) {
      if (value.length === 0) {
        this.msg["nama"] = "Name is Required";
      } else {
        this.msg["nama"] = "";
      }
    },
    validateusername(value) {
      if (value.length === 0) {
        this.msg["username"] = "Username is Required";
      } else {
        this.msg["username"] = "";
      }
    },

    validateEmail(value) {
      if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(value)) {
        this.msg["email"] = "";
      } else if (value.length === 0) {
        this.msg["email"] = " Email Address is Reuqired";
      } else {
        this.msg["email"] = "Invalid Email Address";
      }
    },
  },
};
</script>
